#ifdef RPC_HDR
%#ifndef XATTR_H
%#define XATTR_H
%#define XATTRDPORT 4049
%#ifndef MAIN
%extern int xattrd_socket;
%#endif
#endif

const NFS_MAXPATHLEN    = 1024;

struct geteattrargs {
	string filename<NFS_MAXPATHLEN>;
};

struct seteattrargs {
	string filename<NFS_MAXPATHLEN>;
	unsigned mode;
};

struct res {
	unsigned mode;
};

struct truncateargs {
	string filename<NFS_MAXPATHLEN>;
	unsigned long lenght;
};

program XATTR_PROGRAM {
	version XATTR_VERSION {
		void 
		XATTRPROC_NULL(void) = 0;

		struct res
		XATTRPROC_GETEATTR(geteattrargs) = 1;

		struct res
		XATTRPROC_SETEATTR(seteattrargs) = 2;

		struct res
		XATTRPROC_TRUNCATE(truncateargs) = 3;
	} = 1;
} = 300722;

#ifdef RPC_HDR
%#endif /*XATTR_H*/
#endif
